/* Colors.c generated by valac 0.56.16, the Vala compiler
 * generated from Colors.vala, do not modify */

/*
* Copyright © 2018–2020 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	COLOR_STRAWBERRY,
	COLOR_ORANGE,
	COLOR_BANANA,
	COLOR_LIME,
	COLOR_MINT,
	COLOR_BLUEBERRY,
	COLOR_GRAPE,
	COLOR_BUBBLEGUM,
	COLOR_COCOA,
	COLOR_SILVER,
	COLOR_SLATE,
	COLOR_BLACK
} Color;

#define TYPE_COLOR (color_get_type ())

VALA_EXTERN GType color_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* color_pretty (Color self);
VALA_EXTERN gchar* color_uses (Color self);
VALA_EXTERN gchar* color_style_class (Color self);
VALA_EXTERN GeeHashMap* color_hex (Color self);

gchar*
color_pretty (Color self)
{
	gchar* result;
	switch (self) {
		case COLOR_STRAWBERRY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Strawberry"));
			result = _tmp0_;
			return result;
		}
		case COLOR_ORANGE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Orange"));
			result = _tmp1_;
			return result;
		}
		case COLOR_BANANA:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Banana"));
			result = _tmp2_;
			return result;
		}
		case COLOR_LIME:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Lime"));
			result = _tmp3_;
			return result;
		}
		case COLOR_MINT:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Mint"));
			result = _tmp4_;
			return result;
		}
		case COLOR_BLUEBERRY:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Blueberry"));
			result = _tmp5_;
			return result;
		}
		case COLOR_GRAPE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Grape"));
			result = _tmp6_;
			return result;
		}
		case COLOR_BUBBLEGUM:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Bubblegum"));
			result = _tmp7_;
			return result;
		}
		case COLOR_COCOA:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Cocoa"));
			result = _tmp8_;
			return result;
		}
		case COLOR_SILVER:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("Silver"));
			result = _tmp9_;
			return result;
		}
		case COLOR_SLATE:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup (_ ("Slate"));
			result = _tmp10_;
			return result;
		}
		case COLOR_BLACK:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup (_ ("Black"));
			result = _tmp11_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
color_uses (Color self)
{
	gchar* result;
	switch (self) {
		case COLOR_STRAWBERRY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("alert, stop, delete, error, recording, video"));
			result = _tmp0_;
			return result;
		}
		case COLOR_ORANGE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("music, news, update, presentation"));
			result = _tmp1_;
			return result;
		}
		case COLOR_BANANA:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("caution, warning, mail, history, favorite"));
			result = _tmp2_;
			return result;
		}
		case COLOR_LIME:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("success, start, go, new, event, spreadsheet"));
			result = _tmp3_;
			return result;
		}
		case COLOR_MINT:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("vector path intersections, calming"));
			result = _tmp4_;
			return result;
		}
		case COLOR_BLUEBERRY:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("elementary, default accent, question, help, downloads, document"));
			result = _tmp5_;
			return result;
		}
		case COLOR_GRAPE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("network, sharing, developer, appcenter, beta, vala, programming"));
			result = _tmp6_;
			return result;
		}
		case COLOR_BUBBLEGUM:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("eraser, playful"));
			result = _tmp7_;
			return result;
		}
		case COLOR_COCOA:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("warm neutral, earth tone, brown"));
			result = _tmp8_;
			return result;
		}
		case COLOR_SILVER:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("system, neutral light"));
			result = _tmp9_;
			return result;
		}
		case COLOR_SLATE:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup (_ ("cool neutral, default"));
			result = _tmp10_;
			return result;
		}
		case COLOR_BLACK:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup (_ ("neutral dark"));
			result = _tmp11_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
color_style_class (Color self)
{
	gchar* result;
	switch (self) {
		case COLOR_STRAWBERRY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("strawberry");
			result = _tmp0_;
			return result;
		}
		case COLOR_ORANGE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("orange");
			result = _tmp1_;
			return result;
		}
		case COLOR_BANANA:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("banana");
			result = _tmp2_;
			return result;
		}
		case COLOR_MINT:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("mint");
			result = _tmp3_;
			return result;
		}
		case COLOR_LIME:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("lime");
			result = _tmp4_;
			return result;
		}
		case COLOR_BLUEBERRY:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("blueberry");
			result = _tmp5_;
			return result;
		}
		case COLOR_GRAPE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("grape");
			result = _tmp6_;
			return result;
		}
		case COLOR_BUBBLEGUM:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("bubblegum");
			result = _tmp7_;
			return result;
		}
		case COLOR_COCOA:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("cocoa");
			result = _tmp8_;
			return result;
		}
		case COLOR_SILVER:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("silver");
			result = _tmp9_;
			return result;
		}
		case COLOR_SLATE:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup ("slate");
			result = _tmp10_;
			return result;
		}
		case COLOR_BLACK:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup ("black");
			result = _tmp11_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

GeeHashMap*
color_hex (Color self)
{
	GeeHashMap* hex = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result;
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	hex = _tmp0_;
	switch (self) {
		case COLOR_STRAWBERRY:
		{
			GeeHashMap* _tmp1_;
			GeeHashMap* _tmp2_;
			GeeHashMap* _tmp3_;
			GeeHashMap* _tmp4_;
			GeeHashMap* _tmp5_;
			_tmp1_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) 100), "#ff8c82");
			_tmp2_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) 300), "#ed5353");
			_tmp3_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) 500), "#c6262e");
			_tmp4_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) 700), "#a10705");
			_tmp5_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) 900), "#7a0000");
			break;
		}
		case COLOR_ORANGE:
		{
			GeeHashMap* _tmp6_;
			GeeHashMap* _tmp7_;
			GeeHashMap* _tmp8_;
			GeeHashMap* _tmp9_;
			GeeHashMap* _tmp10_;
			_tmp6_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) 100), "#ffc27d");
			_tmp7_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) 300), "#ffa154");
			_tmp8_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, (gpointer) ((gintptr) 500), "#f37329");
			_tmp9_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) 700), "#cc3b02");
			_tmp10_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) 900), "#a62100");
			break;
		}
		case COLOR_BANANA:
		{
			GeeHashMap* _tmp11_;
			GeeHashMap* _tmp12_;
			GeeHashMap* _tmp13_;
			GeeHashMap* _tmp14_;
			GeeHashMap* _tmp15_;
			_tmp11_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, (gpointer) ((gintptr) 100), "#fff394");
			_tmp12_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, (gpointer) ((gintptr) 300), "#ffe16b");
			_tmp13_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, (gpointer) ((gintptr) 500), "#f9c440");
			_tmp14_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, (gpointer) ((gintptr) 700), "#d48e15");
			_tmp15_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, (gpointer) ((gintptr) 900), "#ad5f00");
			break;
		}
		case COLOR_LIME:
		{
			GeeHashMap* _tmp16_;
			GeeHashMap* _tmp17_;
			GeeHashMap* _tmp18_;
			GeeHashMap* _tmp19_;
			GeeHashMap* _tmp20_;
			_tmp16_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, (gpointer) ((gintptr) 100), "#d1ff82");
			_tmp17_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, (gpointer) ((gintptr) 300), "#9bdb4d");
			_tmp18_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) 500), "#68b723");
			_tmp19_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) 700), "#3a9104");
			_tmp20_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp20_, (gpointer) ((gintptr) 900), "#206b00");
			break;
		}
		case COLOR_MINT:
		{
			GeeHashMap* _tmp21_;
			GeeHashMap* _tmp22_;
			GeeHashMap* _tmp23_;
			GeeHashMap* _tmp24_;
			GeeHashMap* _tmp25_;
			_tmp21_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, (gpointer) ((gintptr) 100), "#89ffdd");
			_tmp22_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, (gpointer) ((gintptr) 300), "#43d6b5");
			_tmp23_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) 500), "#28bca3");
			_tmp24_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, (gpointer) ((gintptr) 700), "#0e9a83");
			_tmp25_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, (gpointer) ((gintptr) 900), "#007367");
			break;
		}
		case COLOR_BLUEBERRY:
		{
			GeeHashMap* _tmp26_;
			GeeHashMap* _tmp27_;
			GeeHashMap* _tmp28_;
			GeeHashMap* _tmp29_;
			GeeHashMap* _tmp30_;
			_tmp26_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp26_, (gpointer) ((gintptr) 100), "#8cd5ff");
			_tmp27_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp27_, (gpointer) ((gintptr) 300), "#64baff");
			_tmp28_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, (gpointer) ((gintptr) 500), "#3689e6");
			_tmp29_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, (gpointer) ((gintptr) 700), "#0d52bf");
			_tmp30_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, (gpointer) ((gintptr) 900), "#002e99");
			break;
		}
		case COLOR_GRAPE:
		{
			GeeHashMap* _tmp31_;
			GeeHashMap* _tmp32_;
			GeeHashMap* _tmp33_;
			GeeHashMap* _tmp34_;
			GeeHashMap* _tmp35_;
			_tmp31_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) 100), "#e4c6fa");
			_tmp32_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, (gpointer) ((gintptr) 300), "#cd9ef7");
			_tmp33_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp33_, (gpointer) ((gintptr) 500), "#a56de2");
			_tmp34_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp34_, (gpointer) ((gintptr) 700), "#7239b3");
			_tmp35_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp35_, (gpointer) ((gintptr) 900), "#452981");
			break;
		}
		case COLOR_BUBBLEGUM:
		{
			GeeHashMap* _tmp36_;
			GeeHashMap* _tmp37_;
			GeeHashMap* _tmp38_;
			GeeHashMap* _tmp39_;
			GeeHashMap* _tmp40_;
			_tmp36_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, (gpointer) ((gintptr) 100), "#fe9ab8");
			_tmp37_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp37_, (gpointer) ((gintptr) 300), "#f4679d");
			_tmp38_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp38_, (gpointer) ((gintptr) 500), "#de3e80");
			_tmp39_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) 700), "#bc245d");
			_tmp40_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp40_, (gpointer) ((gintptr) 900), "#910e38");
			break;
		}
		case COLOR_COCOA:
		{
			GeeHashMap* _tmp41_;
			GeeHashMap* _tmp42_;
			GeeHashMap* _tmp43_;
			GeeHashMap* _tmp44_;
			GeeHashMap* _tmp45_;
			_tmp41_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) 100), "#a3907c");
			_tmp42_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp42_, (gpointer) ((gintptr) 300), "#8a715e");
			_tmp43_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp43_, (gpointer) ((gintptr) 500), "#715344");
			_tmp44_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp44_, (gpointer) ((gintptr) 700), "#57392d");
			_tmp45_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp45_, (gpointer) ((gintptr) 900), "#3d211b");
			break;
		}
		case COLOR_SILVER:
		{
			GeeHashMap* _tmp46_;
			GeeHashMap* _tmp47_;
			GeeHashMap* _tmp48_;
			GeeHashMap* _tmp49_;
			GeeHashMap* _tmp50_;
			_tmp46_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) 100), "#fafafa");
			_tmp47_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp47_, (gpointer) ((gintptr) 300), "#d4d4d4");
			_tmp48_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp48_, (gpointer) ((gintptr) 500), "#abacae");
			_tmp49_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp49_, (gpointer) ((gintptr) 700), "#7e8087");
			_tmp50_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp50_, (gpointer) ((gintptr) 900), "#555761");
			break;
		}
		case COLOR_SLATE:
		{
			GeeHashMap* _tmp51_;
			GeeHashMap* _tmp52_;
			GeeHashMap* _tmp53_;
			GeeHashMap* _tmp54_;
			GeeHashMap* _tmp55_;
			_tmp51_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) 100), "#95a3ab");
			_tmp52_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp52_, (gpointer) ((gintptr) 300), "#667885");
			_tmp53_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, (gpointer) ((gintptr) 500), "#485a6c");
			_tmp54_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, (gpointer) ((gintptr) 700), "#273445");
			_tmp55_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp55_, (gpointer) ((gintptr) 900), "#0e141f");
			break;
		}
		case COLOR_BLACK:
		{
			GeeHashMap* _tmp56_;
			GeeHashMap* _tmp57_;
			GeeHashMap* _tmp58_;
			GeeHashMap* _tmp59_;
			GeeHashMap* _tmp60_;
			_tmp56_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp56_, (gpointer) ((gintptr) 100), "#666666");
			_tmp57_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp57_, (gpointer) ((gintptr) 300), "#4d4d4d");
			_tmp58_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp58_, (gpointer) ((gintptr) 500), "#333333");
			_tmp59_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp59_, (gpointer) ((gintptr) 700), "#1a1a1a");
			_tmp60_ = hex;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp60_, (gpointer) ((gintptr) 900), "#000000");
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	result = hex;
	return result;
}

static GType
color_get_type_once (void)
{
	static const GEnumValue values[] = {{COLOR_STRAWBERRY, "COLOR_STRAWBERRY", "strawberry"}, {COLOR_ORANGE, "COLOR_ORANGE", "orange"}, {COLOR_BANANA, "COLOR_BANANA", "banana"}, {COLOR_LIME, "COLOR_LIME", "lime"}, {COLOR_MINT, "COLOR_MINT", "mint"}, {COLOR_BLUEBERRY, "COLOR_BLUEBERRY", "blueberry"}, {COLOR_GRAPE, "COLOR_GRAPE", "grape"}, {COLOR_BUBBLEGUM, "COLOR_BUBBLEGUM", "bubblegum"}, {COLOR_COCOA, "COLOR_COCOA", "cocoa"}, {COLOR_SILVER, "COLOR_SILVER", "silver"}, {COLOR_SLATE, "COLOR_SLATE", "slate"}, {COLOR_BLACK, "COLOR_BLACK", "black"}, {0, NULL, NULL}};
	GType color_type_id;
	color_type_id = g_enum_register_static ("Color", values);
	return color_type_id;
}

GType
color_get_type (void)
{
	static volatile gsize color_type_id__once = 0;
	if (g_once_init_enter (&color_type_id__once)) {
		GType color_type_id;
		color_type_id = color_get_type_once ();
		g_once_init_leave (&color_type_id__once, color_type_id);
	}
	return color_type_id__once;
}

