/* MiniWindow.c generated by valac 0.56.16, the Vala compiler
 * generated from MiniWindow.vala, do not modify */

/*
* Copyright © 2018–2021 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MINI_WINDOW (mini_window_get_type ())
#define MINI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINI_WINDOW, MiniWindow))
#define MINI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINI_WINDOW, MiniWindowClass))
#define IS_MINI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINI_WINDOW))
#define IS_MINI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINI_WINDOW))
#define MINI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINI_WINDOW, MiniWindowClass))

typedef struct _MiniWindow MiniWindow;
typedef struct _MiniWindowClass MiniWindowClass;
typedef struct _MiniWindowPrivate MiniWindowPrivate;
enum  {
	MINI_WINDOW_0_PROPERTY,
	MINI_WINDOW_MINI_LAYOUT_PROPERTY,
	MINI_WINDOW_NUM_PROPERTIES
};
static GParamSpec* mini_window_properties[MINI_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

#define TYPE_COLOR_BUTTON (color_button_get_type ())
#define COLOR_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_BUTTON, ColorButton))
#define COLOR_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_BUTTON, ColorButtonClass))
#define IS_COLOR_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_BUTTON))
#define IS_COLOR_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_BUTTON))
#define COLOR_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_BUTTON, ColorButtonClass))

typedef struct _ColorButton ColorButton;
typedef struct _ColorButtonClass ColorButtonClass;
typedef enum  {
	COLOR_STRAWBERRY,
	COLOR_ORANGE,
	COLOR_BANANA,
	COLOR_LIME,
	COLOR_MINT,
	COLOR_BLUEBERRY,
	COLOR_GRAPE,
	COLOR_BUBBLEGUM,
	COLOR_COCOA,
	COLOR_SILVER,
	COLOR_SLATE,
	COLOR_BLACK
} Color;

#define TYPE_COLOR (color_get_type ())

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;

struct _MiniWindow {
	GtkWindow parent_instance;
	MiniWindowPrivate * priv;
};

struct _MiniWindowClass {
	GtkWindowClass parent_class;
};

struct _MiniWindowPrivate {
	GtkGrid* _mini_layout;
};

struct _Block2Data {
	int _ref_count_;
	MiniWindow* self;
	gint window_x;
	gint window_y;
};

static gint MiniWindow_private_offset;
static gpointer mini_window_parent_class = NULL;
VALA_EXTERN GSettings* palette_settings;
VALA_EXTERN MainWindow* palette_main_window;

VALA_EXTERN GType mini_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MiniWindow, g_object_unref)
VALA_EXTERN MiniWindow* mini_window_new (GtkApplication* application);
VALA_EXTERN MiniWindow* mini_window_construct (GType object_type,
                                   GtkApplication* application);
static void mini_window_real_realize (GtkWidget* base);
static gint32 _variant_get3 (GVariant* value);
static gint32 _variant_get4 (GVariant* value);
VALA_EXTERN void mini_window_fit_popover (MiniWindow* self,
                              gint window_x,
                              gint window_y,
                              gint display_width,
                              gboolean embiggen,
                              gint popover_width);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN GtkGrid* mini_window_get_mini_layout (MiniWindow* self);
static gboolean ___lambda4_ (Block2Data* _data2_);
static gboolean ____lambda4__gsource_func (gpointer self);
VALA_EXTERN void mini_window_set_mini_layout (MiniWindow* self,
                                  GtkGrid* value);
static GObject * mini_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
VALA_EXTERN GType color_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ColorButton, g_object_unref)
VALA_EXTERN GType color_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ColorButton* color_button_new (Color color,
                               gint size);
VALA_EXTERN ColorButton* color_button_construct (GType object_type,
                                     Color color,
                                     gint size);
static void _mini_window___lambda9_ (MiniWindow* self);
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
static void __mini_window___lambda9__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self);
static void mini_window_finalize (GObject * obj);
static GType mini_window_get_type_once (void);
static void _vala_mini_window_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_mini_window_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
mini_window_get_instance_private (MiniWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MiniWindow_private_offset);
}

MiniWindow*
mini_window_construct (GType object_type,
                       GtkApplication* application)
{
	MiniWindow * self = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	self = (MiniWindow*) g_object_new (object_type, "application", application, "icon-name", "com.github.cassidyjames.palette", "resizable", FALSE, "skip-taskbar-hint", TRUE, NULL);
	return self;
}

MiniWindow*
mini_window_new (GtkApplication* application)
{
	return mini_window_construct (TYPE_MINI_WINDOW, application);
}

static gint32
_variant_get3 (GVariant* value)
{
	return g_variant_get_int32 (value);
}

static gint32
_variant_get4 (GVariant* value)
{
	return g_variant_get_int32 (value);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
mini_window_real_realize (GtkWidget* base)
{
	MiniWindow * self;
	gint32 x = 0;
	gint32 y = 0;
	GVariant* mini_position = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	self = (MiniWindow*) base;
	GTK_WIDGET_CLASS (mini_window_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
	x = (gint32) 0;
	y = (gint32) 0;
	_tmp0_ = palette_settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "mini-position");
	mini_position = _tmp1_;
	_tmp2_ = mini_position;
	if (g_variant_n_children (_tmp2_) == ((gsize) 2)) {
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		gint32 _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
		gint32 _tmp10_;
		_tmp3_ = mini_position;
		_tmp4_ = g_variant_get_child_value (_tmp3_, (gsize) 0);
		_tmp5_ = _tmp4_;
		_tmp6_ = _variant_get3 (_tmp5_);
		x = _tmp6_;
		_g_variant_unref0 (_tmp5_);
		_tmp7_ = mini_position;
		_tmp8_ = g_variant_get_child_value (_tmp7_, (gsize) 1);
		_tmp9_ = _tmp8_;
		_tmp10_ = _variant_get4 (_tmp9_);
		y = _tmp10_;
		_g_variant_unref0 (_tmp9_);
	} else {
		gint width = 0;
		gint height = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		GdkScreen* screen = NULL;
		GdkScreen* _tmp13_;
		GdkScreen* _tmp14_;
		GdkDisplay* display = NULL;
		GdkScreen* _tmp15_;
		GdkDisplay* _tmp16_;
		GdkDisplay* _tmp17_;
		GdkMonitor* monitor = NULL;
		GdkDisplay* _tmp18_;
		GdkMonitor* _tmp19_;
		GdkMonitor* _tmp20_;
		GdkRectangle geometry = {0};
		GdkMonitor* _tmp21_;
		GdkRectangle _tmp22_ = {0};
		GdkRectangle _tmp23_;
		GdkRectangle _tmp24_;
		gtk_window_get_size ((GtkWindow*) self, &_tmp11_, &_tmp12_);
		width = _tmp11_;
		height = _tmp12_;
		_tmp13_ = gdk_screen_get_default ();
		_tmp14_ = _g_object_ref0 (_tmp13_);
		screen = _tmp14_;
		_tmp15_ = screen;
		_tmp16_ = gdk_screen_get_display (_tmp15_);
		_tmp17_ = _g_object_ref0 (_tmp16_);
		display = _tmp17_;
		_tmp18_ = display;
		_tmp19_ = gdk_display_get_primary_monitor (_tmp18_);
		_tmp20_ = _g_object_ref0 (_tmp19_);
		monitor = _tmp20_;
		_tmp21_ = monitor;
		gdk_monitor_get_geometry (_tmp21_, &_tmp22_);
		_tmp23_ = _tmp22_;
		geometry = _tmp23_;
		_tmp24_ = geometry;
		y = (gint32) ((_tmp24_.height / 2) - (height / 2));
		_g_object_unref0 (monitor);
		_g_object_unref0 (display);
		_g_object_unref0 (screen);
	}
	gtk_window_move ((GtkWindow*) self, (gint) x, (gint) y);
	_g_variant_unref0 (mini_position);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		MiniWindow* self;
		self = _data2_->self;
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gboolean
___lambda4_ (Block2Data* _data2_)
{
	MiniWindow* self;
	gboolean result;
	self = _data2_->self;
	gtk_window_move ((GtkWindow*) self, _data2_->window_x, _data2_->window_y);
	result = FALSE;
	return result;
}

static gboolean
____lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda4_ (self);
	return result;
}

void
mini_window_fit_popover (MiniWindow* self,
                         gint window_x,
                         gint window_y,
                         gint display_width,
                         gboolean embiggen,
                         gint popover_width)
{
	Block2Data* _data2_;
	g_return_if_fail (self != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_data2_->window_x = window_x;
	_data2_->window_y = window_y;
	if (embiggen) {
		if (((gdouble) _data2_->window_x) > (display_width * 0.75)) {
			GtkGrid* _tmp0_;
			_tmp0_ = self->priv->_mini_layout;
			gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_END);
		} else {
			GtkGrid* _tmp1_;
			_tmp1_ = self->priv->_mini_layout;
			gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
		}
		g_object_set ((GtkWidget*) self, "width-request", gtk_widget_get_allocated_width ((GtkWidget*) self) + popover_width, NULL);
	} else {
		g_object_set ((GtkWidget*) self, "width-request", -1, NULL);
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda4__gsource_func, block2_data_ref (_data2_), block2_data_unref);
	}
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

GtkGrid*
mini_window_get_mini_layout (MiniWindow* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_mini_layout;
	result = _tmp0_;
	return result;
}

void
mini_window_set_mini_layout (MiniWindow* self,
                             GtkGrid* value)
{
	GtkGrid* old_value;
	g_return_if_fail (self != NULL);
	old_value = mini_window_get_mini_layout (self);
	if (old_value != value) {
		GtkGrid* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_mini_layout);
		self->priv->_mini_layout = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, mini_window_properties[MINI_WINDOW_MINI_LAYOUT_PROPERTY]);
	}
}

static void
_mini_window___lambda9_ (MiniWindow* self)
{
	GSettings* _tmp0_;
	MainWindow* _tmp1_;
	_tmp0_ = palette_settings;
	g_settings_set_boolean (_tmp0_, "mini-mode", FALSE);
	_tmp1_ = palette_main_window;
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
	gtk_widget_hide ((GtkWidget*) self);
}

static void
__mini_window___lambda9__gtk_button_clicked (GtkButton* _sender,
                                             gpointer self)
{
	_mini_window___lambda9_ ((MiniWindow*) self);
}

static GObject *
mini_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MiniWindow * self;
	GtkButton* restore_button = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkStyleContext* restore_button_context = NULL;
	GtkButton* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkHeaderBar* header = NULL;
	GtkHeaderBar* _tmp9_;
	GtkHeaderBar* _tmp10_;
	GtkHeaderBar* _tmp11_;
	GtkButton* _tmp12_;
	GtkHeaderBar* _tmp13_;
	GtkStyleContext* header_context = NULL;
	GtkHeaderBar* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkStyleContext* _tmp19_;
	ColorButton* strawberry_button = NULL;
	ColorButton* _tmp20_;
	ColorButton* orange_button = NULL;
	ColorButton* _tmp21_;
	ColorButton* banana_button = NULL;
	ColorButton* _tmp22_;
	ColorButton* lime_button = NULL;
	ColorButton* _tmp23_;
	ColorButton* mint_button = NULL;
	ColorButton* _tmp24_;
	ColorButton* blueberry_button = NULL;
	ColorButton* _tmp25_;
	ColorButton* grape_button = NULL;
	ColorButton* _tmp26_;
	ColorButton* bubblegum_button = NULL;
	ColorButton* _tmp27_;
	ColorButton* cocoa_button = NULL;
	ColorButton* _tmp28_;
	ColorButton* silver_button = NULL;
	ColorButton* _tmp29_;
	ColorButton* slate_button = NULL;
	ColorButton* _tmp30_;
	ColorButton* black_button = NULL;
	ColorButton* _tmp31_;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkGrid* _tmp37_;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	gint row = 0;
	GtkGrid* _tmp40_;
	ColorButton* _tmp41_;
	gint _tmp42_;
	GtkGrid* _tmp43_;
	ColorButton* _tmp44_;
	gint _tmp45_;
	GtkGrid* _tmp46_;
	ColorButton* _tmp47_;
	gint _tmp48_;
	GtkGrid* _tmp49_;
	ColorButton* _tmp50_;
	gint _tmp51_;
	GtkGrid* _tmp52_;
	ColorButton* _tmp53_;
	gint _tmp54_;
	GtkGrid* _tmp55_;
	ColorButton* _tmp56_;
	gint _tmp57_;
	GtkGrid* _tmp58_;
	ColorButton* _tmp59_;
	gint _tmp60_;
	GtkGrid* _tmp61_;
	ColorButton* _tmp62_;
	gint _tmp63_;
	GtkGrid* _tmp64_;
	ColorButton* _tmp65_;
	gint _tmp66_;
	GtkGrid* _tmp67_;
	ColorButton* _tmp68_;
	gint _tmp69_;
	GtkGrid* _tmp70_;
	ColorButton* _tmp71_;
	gint _tmp72_;
	GtkGrid* _tmp73_;
	ColorButton* _tmp74_;
	gint _tmp75_;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp76_;
	GtkStyleContext* _tmp77_;
	GtkStyleContext* _tmp78_;
	GtkStyleContext* _tmp79_;
	GtkStyleContext* _tmp80_;
	GtkStyleContext* _tmp81_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp82_;
	GtkSettings* _tmp83_;
	GtkSettings* _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	GtkHeaderBar* _tmp88_;
	GtkGrid* _tmp89_;
	GtkButton* _tmp90_;
	parent_class = G_OBJECT_CLASS (mini_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINI_WINDOW, MiniWindow);
	gtk_window_stick ((GtkWindow*) self);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name ("window-pop-out-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp0_);
	restore_button = _tmp0_;
	_tmp1_ = restore_button;
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
	_tmp2_ = restore_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _ ("Windowed mode"));
	_tmp3_ = restore_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	_tmp4_ = restore_button;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	_tmp6_ = _g_object_ref0 (_tmp5_);
	restore_button_context = _tmp6_;
	_tmp7_ = restore_button_context;
	gtk_style_context_add_class (_tmp7_, "titlebutton");
	_tmp8_ = restore_button_context;
	gtk_style_context_remove_class (_tmp8_, "image-button");
	_tmp9_ = (GtkHeaderBar*) gtk_header_bar_new ();
	g_object_ref_sink (_tmp9_);
	header = _tmp9_;
	_tmp10_ = header;
	gtk_header_bar_set_has_subtitle (_tmp10_, FALSE);
	_tmp11_ = header;
	_tmp12_ = restore_button;
	gtk_header_bar_set_custom_title (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = header;
	gtk_header_bar_set_show_close_button (_tmp13_, FALSE);
	_tmp14_ = header;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	_tmp16_ = _g_object_ref0 (_tmp15_);
	header_context = _tmp16_;
	_tmp17_ = header_context;
	gtk_style_context_add_class (_tmp17_, "titlebar");
	_tmp18_ = header_context;
	gtk_style_context_add_class (_tmp18_, "default-decoration");
	_tmp19_ = header_context;
	gtk_style_context_add_class (_tmp19_, GTK_STYLE_CLASS_FLAT);
	_tmp20_ = color_button_new (COLOR_STRAWBERRY, 32);
	g_object_ref_sink (_tmp20_);
	strawberry_button = _tmp20_;
	_tmp21_ = color_button_new (COLOR_ORANGE, 32);
	g_object_ref_sink (_tmp21_);
	orange_button = _tmp21_;
	_tmp22_ = color_button_new (COLOR_BANANA, 32);
	g_object_ref_sink (_tmp22_);
	banana_button = _tmp22_;
	_tmp23_ = color_button_new (COLOR_LIME, 32);
	g_object_ref_sink (_tmp23_);
	lime_button = _tmp23_;
	_tmp24_ = color_button_new (COLOR_MINT, 32);
	g_object_ref_sink (_tmp24_);
	mint_button = _tmp24_;
	_tmp25_ = color_button_new (COLOR_BLUEBERRY, 32);
	g_object_ref_sink (_tmp25_);
	blueberry_button = _tmp25_;
	_tmp26_ = color_button_new (COLOR_GRAPE, 32);
	g_object_ref_sink (_tmp26_);
	grape_button = _tmp26_;
	_tmp27_ = color_button_new (COLOR_BUBBLEGUM, 32);
	g_object_ref_sink (_tmp27_);
	bubblegum_button = _tmp27_;
	_tmp28_ = color_button_new (COLOR_COCOA, 32);
	g_object_ref_sink (_tmp28_);
	cocoa_button = _tmp28_;
	_tmp29_ = color_button_new (COLOR_SILVER, 32);
	g_object_ref_sink (_tmp29_);
	silver_button = _tmp29_;
	_tmp30_ = color_button_new (COLOR_SLATE, 32);
	g_object_ref_sink (_tmp30_);
	slate_button = _tmp30_;
	_tmp31_ = color_button_new (COLOR_BLACK, 32);
	g_object_ref_sink (_tmp31_);
	black_button = _tmp31_;
	_tmp32_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp32_);
	_tmp33_ = _tmp32_;
	mini_window_set_mini_layout (self, _tmp33_);
	_g_object_unref0 (_tmp33_);
	_tmp34_ = self->priv->_mini_layout;
	_tmp35_ = self->priv->_mini_layout;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp35_, 12);
	gtk_grid_set_row_spacing (_tmp34_, 12);
	_tmp36_ = self->priv->_mini_layout;
	_tmp37_ = self->priv->_mini_layout;
	_tmp38_ = self->priv->_mini_layout;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp38_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp37_, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp36_, 6);
	_tmp39_ = self->priv->_mini_layout;
	gtk_widget_set_halign ((GtkWidget*) _tmp39_, GTK_ALIGN_END);
	row = 0;
	_tmp40_ = self->priv->_mini_layout;
	_tmp41_ = strawberry_button;
	_tmp42_ = row;
	row = _tmp42_ + 1;
	gtk_grid_attach (_tmp40_, (GtkWidget*) _tmp41_, 0, _tmp42_, 1, 1);
	_tmp43_ = self->priv->_mini_layout;
	_tmp44_ = orange_button;
	_tmp45_ = row;
	row = _tmp45_ + 1;
	gtk_grid_attach (_tmp43_, (GtkWidget*) _tmp44_, 0, _tmp45_, 1, 1);
	_tmp46_ = self->priv->_mini_layout;
	_tmp47_ = banana_button;
	_tmp48_ = row;
	row = _tmp48_ + 1;
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, 0, _tmp48_, 1, 1);
	_tmp49_ = self->priv->_mini_layout;
	_tmp50_ = lime_button;
	_tmp51_ = row;
	row = _tmp51_ + 1;
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 0, _tmp51_, 1, 1);
	_tmp52_ = self->priv->_mini_layout;
	_tmp53_ = mint_button;
	_tmp54_ = row;
	row = _tmp54_ + 1;
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 0, _tmp54_, 1, 1);
	_tmp55_ = self->priv->_mini_layout;
	_tmp56_ = blueberry_button;
	_tmp57_ = row;
	row = _tmp57_ + 1;
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 0, _tmp57_, 1, 1);
	_tmp58_ = self->priv->_mini_layout;
	_tmp59_ = grape_button;
	_tmp60_ = row;
	row = _tmp60_ + 1;
	gtk_grid_attach (_tmp58_, (GtkWidget*) _tmp59_, 0, _tmp60_, 1, 1);
	_tmp61_ = self->priv->_mini_layout;
	_tmp62_ = bubblegum_button;
	_tmp63_ = row;
	row = _tmp63_ + 1;
	gtk_grid_attach (_tmp61_, (GtkWidget*) _tmp62_, 0, _tmp63_, 1, 1);
	_tmp64_ = self->priv->_mini_layout;
	_tmp65_ = cocoa_button;
	_tmp66_ = row;
	row = _tmp66_ + 1;
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 0, _tmp66_, 1, 1);
	_tmp67_ = self->priv->_mini_layout;
	_tmp68_ = silver_button;
	_tmp69_ = row;
	row = _tmp69_ + 1;
	gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, 0, _tmp69_, 1, 1);
	_tmp70_ = self->priv->_mini_layout;
	_tmp71_ = slate_button;
	_tmp72_ = row;
	row = _tmp72_ + 1;
	gtk_grid_attach (_tmp70_, (GtkWidget*) _tmp71_, 0, _tmp72_, 1, 1);
	_tmp73_ = self->priv->_mini_layout;
	_tmp74_ = black_button;
	_tmp75_ = row;
	row = _tmp75_ + 1;
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 0, _tmp75_, 1, 1);
	_tmp76_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp77_ = _g_object_ref0 (_tmp76_);
	context = _tmp77_;
	_tmp78_ = context;
	gtk_style_context_add_class (_tmp78_, "palette");
	_tmp79_ = context;
	gtk_style_context_add_class (_tmp79_, "mini");
	_tmp80_ = context;
	gtk_style_context_add_class (_tmp80_, "rounded");
	_tmp81_ = context;
	gtk_style_context_add_class (_tmp81_, "flat");
	_tmp82_ = gtk_settings_get_default ();
	_tmp83_ = _g_object_ref0 (_tmp82_);
	gtk_settings = _tmp83_;
	_tmp84_ = gtk_settings;
	g_object_get (_tmp84_, "gtk-application-prefer-dark-theme", &_tmp85_, NULL);
	_tmp86_ = _tmp85_;
	if (_tmp86_) {
		GtkStyleContext* _tmp87_;
		_tmp87_ = context;
		gtk_style_context_add_class (_tmp87_, "dark");
	}
	_tmp88_ = header;
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp88_);
	_tmp89_ = self->priv->_mini_layout;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp89_);
	_tmp90_ = restore_button;
	g_signal_connect_object (_tmp90_, "clicked", (GCallback) __mini_window___lambda9__gtk_button_clicked, self, 0);
	_g_object_unref0 (gtk_settings);
	_g_object_unref0 (context);
	_g_object_unref0 (black_button);
	_g_object_unref0 (slate_button);
	_g_object_unref0 (silver_button);
	_g_object_unref0 (cocoa_button);
	_g_object_unref0 (bubblegum_button);
	_g_object_unref0 (grape_button);
	_g_object_unref0 (blueberry_button);
	_g_object_unref0 (mint_button);
	_g_object_unref0 (lime_button);
	_g_object_unref0 (banana_button);
	_g_object_unref0 (orange_button);
	_g_object_unref0 (strawberry_button);
	_g_object_unref0 (header_context);
	_g_object_unref0 (header);
	_g_object_unref0 (restore_button_context);
	_g_object_unref0 (restore_button);
	return obj;
}

static void
mini_window_class_init (MiniWindowClass * klass,
                        gpointer klass_data)
{
	mini_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MiniWindow_private_offset);
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) mini_window_real_realize;
	G_OBJECT_CLASS (klass)->get_property = _vala_mini_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mini_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = mini_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = mini_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINI_WINDOW_MINI_LAYOUT_PROPERTY, mini_window_properties[MINI_WINDOW_MINI_LAYOUT_PROPERTY] = g_param_spec_object ("mini-layout", "mini-layout", "mini-layout", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
mini_window_instance_init (MiniWindow * self,
                           gpointer klass)
{
	self->priv = mini_window_get_instance_private (self);
}

static void
mini_window_finalize (GObject * obj)
{
	MiniWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINI_WINDOW, MiniWindow);
	_g_object_unref0 (self->priv->_mini_layout);
	G_OBJECT_CLASS (mini_window_parent_class)->finalize (obj);
}

static GType
mini_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MiniWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mini_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MiniWindow), 0, (GInstanceInitFunc) mini_window_instance_init, NULL };
	GType mini_window_type_id;
	mini_window_type_id = g_type_register_static (gtk_window_get_type (), "MiniWindow", &g_define_type_info, 0);
	MiniWindow_private_offset = g_type_add_instance_private (mini_window_type_id, sizeof (MiniWindowPrivate));
	return mini_window_type_id;
}

GType
mini_window_get_type (void)
{
	static volatile gsize mini_window_type_id__once = 0;
	if (g_once_init_enter (&mini_window_type_id__once)) {
		GType mini_window_type_id;
		mini_window_type_id = mini_window_get_type_once ();
		g_once_init_leave (&mini_window_type_id__once, mini_window_type_id);
	}
	return mini_window_type_id__once;
}

static void
_vala_mini_window_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	MiniWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINI_WINDOW, MiniWindow);
	switch (property_id) {
		case MINI_WINDOW_MINI_LAYOUT_PROPERTY:
		g_value_set_object (value, mini_window_get_mini_layout (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_mini_window_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	MiniWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINI_WINDOW, MiniWindow);
	switch (property_id) {
		case MINI_WINDOW_MINI_LAYOUT_PROPERTY:
		mini_window_set_mini_layout (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

