/* ColorButton.c generated by valac 0.56.16, the Vala compiler
 * generated from ColorButton.vala, do not modify */

/*
* Copyright © 2018–2021 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <cairo-gobject.h>

#define COLOR_BUTTON_BUTTON_CSS "\n" \
"        .%s-%i {\n" \
"            background: %s;\n" \
"            color: %s;\n" \
"        }\n" \
"\n" \
"        .fg-%s-%i {\n" \
"            color: %s;\n" \
"        }\n" \
"    "
#define COLOR_BUTTON_BLACK "#000"
#define COLOR_BUTTON_WHITE "#fff"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_COLOR_BUTTON (color_button_get_type ())
#define COLOR_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_BUTTON, ColorButton))
#define COLOR_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_BUTTON, ColorButtonClass))
#define IS_COLOR_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_BUTTON))
#define IS_COLOR_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_BUTTON))
#define COLOR_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_BUTTON, ColorButtonClass))

typedef struct _ColorButton ColorButton;
typedef struct _ColorButtonClass ColorButtonClass;
typedef struct _ColorButtonPrivate ColorButtonPrivate;
typedef enum  {
	COLOR_STRAWBERRY,
	COLOR_ORANGE,
	COLOR_BANANA,
	COLOR_LIME,
	COLOR_MINT,
	COLOR_BLUEBERRY,
	COLOR_GRAPE,
	COLOR_BUBBLEGUM,
	COLOR_COCOA,
	COLOR_SILVER,
	COLOR_SLATE,
	COLOR_BLACK
} Color;

#define TYPE_COLOR (color_get_type ())
enum  {
	COLOR_BUTTON_0_PROPERTY,
	COLOR_BUTTON_COLOR_PROPERTY,
	COLOR_BUTTON_NUM_PROPERTIES
};
static GParamSpec* color_button_properties[COLOR_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;

#define TYPE_COLOR_VARIANT (color_variant_get_type ())
#define COLOR_VARIANT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_VARIANT, ColorVariant))
#define COLOR_VARIANT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_VARIANT, ColorVariantClass))
#define IS_COLOR_VARIANT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_VARIANT))
#define IS_COLOR_VARIANT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_VARIANT))
#define COLOR_VARIANT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_VARIANT, ColorVariantClass))

typedef struct _ColorVariant ColorVariant;
typedef struct _ColorVariantClass ColorVariantClass;

#define TYPE_MINI_WINDOW (mini_window_get_type ())
#define MINI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINI_WINDOW, MiniWindow))
#define MINI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINI_WINDOW, MiniWindowClass))
#define IS_MINI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINI_WINDOW))
#define IS_MINI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINI_WINDOW))
#define MINI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINI_WINDOW, MiniWindowClass))

typedef struct _MiniWindow MiniWindow;
typedef struct _MiniWindowClass MiniWindowClass;

struct _ColorButton {
	GtkMenuButton parent_instance;
	ColorButtonPrivate * priv;
};

struct _ColorButtonClass {
	GtkMenuButtonClass parent_class;
};

struct _ColorButtonPrivate {
	Color _color;
};

struct _Block3Data {
	int _ref_count_;
	ColorButton* self;
	GtkPopover* color_menu;
	gint root_x;
	gint root_y;
	GdkRectangle geometry;
};

static gint ColorButton_private_offset;
static gpointer color_button_parent_class = NULL;
VALA_EXTERN MiniWindow* palette_mini_window;

VALA_EXTERN GType color_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ColorButton, g_object_unref)
VALA_EXTERN GType color_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ColorButton* color_button_new (Color color,
                               gint size);
VALA_EXTERN ColorButton* color_button_construct (GType object_type,
                                     Color color,
                                     gint size);
VALA_EXTERN gchar* color_pretty (Color self);
static void color_button_add_styles (ColorButton* self,
                              const gchar* class_name,
                              gint variant,
                              const gchar* bg_color);
static gdouble color_button_contrast_ratio (ColorButton* self,
                                     GdkRGBA* bg_color,
                                     GdkRGBA* fg_color);
static gdouble color_button_get_luminance (ColorButton* self,
                                    GdkRGBA* color);
static gdouble color_button_sanitize_color (ColorButton* self,
                                     gdouble color);
VALA_EXTERN Color color_button_get_color (ColorButton* self);
static void color_button_set_color (ColorButton* self,
                             Color value);
static GObject * color_button_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN gchar* color_style_class (Color self);
VALA_EXTERN gchar* color_uses (Color self);
VALA_EXTERN GType color_variant_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ColorVariant, g_object_unref)
VALA_EXTERN ColorVariant* color_variant_new (Color color,
                                 gint variant,
                                 GtkPopover* color_menu,
                                 GraniteModeSwitch* toggle);
VALA_EXTERN ColorVariant* color_variant_construct (GType object_type,
                                       Color color,
                                       gint variant,
                                       GtkPopover* color_menu,
                                       GraniteModeSwitch* toggle);
VALA_EXTERN GeeHashMap* color_hex (Color self);
static void _color_button___lambda7_ (Block3Data* _data3_);
VALA_EXTERN GType mini_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MiniWindow, g_object_unref)
VALA_EXTERN void mini_window_fit_popover (MiniWindow* self,
                              gint window_x,
                              gint window_y,
                              gint display_width,
                              gboolean embiggen,
                              gint popover_width);
static void __color_button___lambda7__gtk_widget_map (GtkWidget* _sender,
                                               gpointer self);
static void _color_button___lambda8_ (Block3Data* _data3_);
static void __color_button___lambda8__gtk_widget_unmap (GtkWidget* _sender,
                                                 gpointer self);
static void color_button_finalize (GObject * obj);
static GType color_button_get_type_once (void);
static void _vala_color_button_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_color_button_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static const gint COLOR_BUTTON_VARIANTS[5] = {100, 300, 500, 700, 900};

static inline gpointer
color_button_get_instance_private (ColorButton* self)
{
	return G_STRUCT_MEMBER_P (self, ColorButton_private_offset);
}

ColorButton*
color_button_construct (GType object_type,
                        Color color,
                        gint size)
{
	ColorButton * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = color_pretty (color);
	_tmp1_ = _tmp0_;
	self = (ColorButton*) g_object_new (object_type, "height-request", size, "width-request", size, "color", color, "tooltip-text", _tmp1_, NULL);
	_g_free0 (_tmp1_);
	return self;
}

ColorButton*
color_button_new (Color color,
                  gint size)
{
	return color_button_construct (TYPE_COLOR_BUTTON, color, size);
}

static void
color_button_add_styles (ColorButton* self,
                         const gchar* class_name,
                         gint variant,
                         const gchar* bg_color)
{
	GdkRGBA gdk_white = {0};
	GdkRGBA gdk_black = {0};
	GdkRGBA gdk_bg = {0};
	gdouble contrast_white = 0.0;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	gdouble contrast_black = 0.0;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
	gchar* fg_color = NULL;
	gchar* _tmp4_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp6_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (class_name != NULL);
	g_return_if_fail (bg_color != NULL);
	memset (&gdk_white, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&gdk_white, COLOR_BUTTON_WHITE);
	memset (&gdk_black, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&gdk_black, COLOR_BUTTON_BLACK);
	memset (&gdk_bg, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&gdk_bg, bg_color);
	_tmp0_ = gdk_bg;
	_tmp1_ = gdk_white;
	contrast_white = color_button_contrast_ratio (self, &_tmp0_, &_tmp1_);
	_tmp2_ = gdk_bg;
	_tmp3_ = gdk_black;
	contrast_black = color_button_contrast_ratio (self, &_tmp2_, &_tmp3_);
	_tmp4_ = g_strdup (COLOR_BUTTON_WHITE);
	fg_color = _tmp4_;
	if (contrast_black > (contrast_white + 3)) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (COLOR_BUTTON_BLACK);
		_g_free0 (fg_color);
		fg_color = _tmp5_;
	}
	_tmp6_ = gtk_css_provider_new ();
	provider = _tmp6_;
	{
		gchar* colored_css = NULL;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		GtkCssProvider* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		GdkScreen* _tmp14_;
		GtkCssProvider* _tmp15_;
		_tmp7_ = fg_color;
		_tmp8_ = g_strdup_printf (COLOR_BUTTON_BUTTON_CSS, class_name, variant, bg_color, _tmp7_, class_name, variant, bg_color);
		colored_css = _tmp8_;
		_tmp9_ = provider;
		_tmp10_ = colored_css;
		_tmp11_ = colored_css;
		_tmp12_ = strlen (_tmp11_);
		_tmp13_ = _tmp12_;
		gtk_css_provider_load_from_data (_tmp9_, _tmp10_, (gssize) _tmp13_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (colored_css);
			goto __catch0_g_error;
		}
		_tmp14_ = gdk_screen_get_default ();
		_tmp15_ = provider;
		gtk_style_context_add_provider_for_screen (_tmp14_, (GtkStyleProvider*) _tmp15_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
		_g_free0 (colored_css);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		_g_object_unref0 (provider);
		_g_free0 (fg_color);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (provider);
		_g_free0 (fg_color);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (provider);
	_g_free0 (fg_color);
}

static gdouble
color_button_contrast_ratio (ColorButton* self,
                             GdkRGBA* bg_color,
                             GdkRGBA* fg_color)
{
	gdouble bg_luminance = 0.0;
	GdkRGBA _tmp0_;
	gdouble fg_luminance = 0.0;
	GdkRGBA _tmp1_;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (bg_color != NULL, 0.0);
	g_return_val_if_fail (fg_color != NULL, 0.0);
	_tmp0_ = *bg_color;
	bg_luminance = color_button_get_luminance (self, &_tmp0_);
	_tmp1_ = *fg_color;
	fg_luminance = color_button_get_luminance (self, &_tmp1_);
	if (bg_luminance > fg_luminance) {
		result = (bg_luminance + 0.05) / (fg_luminance + 0.05);
		return result;
	}
	result = (fg_luminance + 0.05) / (bg_luminance + 0.05);
	return result;
}

static gdouble
color_button_get_luminance (ColorButton* self,
                            GdkRGBA* color)
{
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble green = 0.0;
	GdkRGBA _tmp1_;
	gdouble blue = 0.0;
	GdkRGBA _tmp2_;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (color != NULL, 0.0);
	_tmp0_ = *color;
	red = color_button_sanitize_color (self, _tmp0_.red) * 0.2126;
	_tmp1_ = *color;
	green = color_button_sanitize_color (self, _tmp1_.green) * 0.7152;
	_tmp2_ = *color;
	blue = color_button_sanitize_color (self, _tmp2_.blue) * 0.0722;
	result = (red + green) + blue;
	return result;
}

static gdouble
color_button_sanitize_color (ColorButton* self,
                             gdouble color)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	if (color <= 0.03928) {
		result = color / 12.92;
		return result;
	}
	result = pow ((color + 0.055) / 1.055, 2.4);
	return result;
}

Color
color_button_get_color (ColorButton* self)
{
	Color result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_color;
	return result;
}

static void
color_button_set_color (ColorButton* self,
                        Color value)
{
	Color old_value;
	g_return_if_fail (self != NULL);
	old_value = color_button_get_color (self);
	if (old_value != value) {
		self->priv->_color = value;
		g_object_notify_by_pspec ((GObject *) self, color_button_properties[COLOR_BUTTON_COLOR_PROPERTY]);
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		ColorButton* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->color_menu);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_color_button___lambda7_ (Block3Data* _data3_)
{
	ColorButton* self;
	MiniWindow* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	MiniWindow* _tmp3_;
	GdkRectangle _tmp4_;
	GtkPopover* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	self = _data3_->self;
	_tmp0_ = palette_mini_window;
	gtk_window_get_position ((GtkWindow*) _tmp0_, &_tmp1_, &_tmp2_);
	_data3_->root_x = _tmp1_;
	_data3_->root_y = _tmp2_;
	_tmp3_ = palette_mini_window;
	_tmp4_ = _data3_->geometry;
	_tmp5_ = _data3_->color_menu;
	g_object_get ((GtkWidget*) _tmp5_, "width-request", &_tmp6_, NULL);
	_tmp7_ = _tmp6_;
	mini_window_fit_popover (_tmp3_, _data3_->root_x, _data3_->root_y, _tmp4_.width, TRUE, _tmp7_);
}

static void
__color_button___lambda7__gtk_widget_map (GtkWidget* _sender,
                                          gpointer self)
{
	_color_button___lambda7_ (self);
}

static void
_color_button___lambda8_ (Block3Data* _data3_)
{
	ColorButton* self;
	MiniWindow* _tmp0_;
	self = _data3_->self;
	_tmp0_ = palette_mini_window;
	mini_window_fit_popover (_tmp0_, _data3_->root_x, _data3_->root_y, 0, FALSE, 0);
}

static void
__color_button___lambda8__gtk_widget_unmap (GtkWidget* _sender,
                                            gpointer self)
{
	_color_button___lambda8_ (self);
}

static GObject *
color_button_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ColorButton * self;
	Block3Data* _data3_;
	GtkStyleContext* color_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkGrid* color_grid = NULL;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GtkGrid* _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
	GtkLabel* title = NULL;
	Color _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkStyleContext* title_context = NULL;
	GtkLabel* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkStyleContext* _tmp24_;
	Color _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GraniteModeSwitch* toggle = NULL;
	GraniteModeSwitch* _tmp30_;
	GraniteModeSwitch* _tmp31_;
	GraniteModeSwitch* _tmp32_;
	GraniteModeSwitch* _tmp33_;
	GraniteModeSwitch* _tmp34_;
	GraniteModeSwitch* _tmp35_;
	GraniteModeSwitch* _tmp36_;
	GtkStyleContext* _tmp37_;
	Color _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GtkLabel* uses_label = NULL;
	Color _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	GtkStyleContext* _tmp56_;
	Color _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gint row = 0;
	gint title_row = 0;
	gint _tmp77_;
	GtkGrid* _tmp78_;
	GtkLabel* _tmp79_;
	GtkGrid* _tmp80_;
	GraniteModeSwitch* _tmp81_;
	GtkGrid* _tmp82_;
	GtkLabel* _tmp83_;
	gint _tmp84_;
	GtkStyleContext* _tmp85_;
	Color _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	GtkGrid* _tmp91_;
	GtkPopover* _tmp92_;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp93_;
	GdkScreen* _tmp94_;
	GdkDisplay* display = NULL;
	GdkScreen* _tmp95_;
	GdkDisplay* _tmp96_;
	GdkDisplay* _tmp97_;
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp98_;
	GdkMonitor* _tmp99_;
	GdkMonitor* _tmp100_;
	GdkMonitor* _tmp101_;
	GdkRectangle _tmp102_ = {0};
	GdkRectangle _tmp103_;
	GtkPopover* _tmp104_;
	GtkPopover* _tmp105_;
	parent_class = G_OBJECT_CLASS (color_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLOR_BUTTON, ColorButton);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	color_context = _tmp1_;
	_tmp2_ = color_context;
	gtk_style_context_add_class (_tmp2_, "circular");
	_tmp3_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp3_);
	color_grid = _tmp3_;
	_tmp4_ = color_grid;
	g_object_set ((GtkWidget*) _tmp4_, "width-request", 32, NULL);
	_tmp5_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
	g_object_ref_sink (_tmp5_);
	_data3_->color_menu = _tmp5_;
	_tmp6_ = _data3_->color_menu;
	_tmp7_ = color_grid;
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = _data3_->color_menu;
	gtk_popover_set_position (_tmp8_, GTK_POS_BOTTOM);
	_tmp9_ = _data3_->color_menu;
	g_object_set ((GtkWidget*) _tmp9_, "width-request", 256, NULL);
	_tmp10_ = self->priv->_color;
	_tmp11_ = color_pretty (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
	g_object_ref_sink (_tmp13_);
	_tmp14_ = _tmp13_;
	_g_free0 (_tmp12_);
	title = _tmp14_;
	_tmp15_ = title;
	gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_START);
	_tmp16_ = title;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
	_tmp17_ = title;
	_tmp18_ = title;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp18_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp17_, 6);
	_tmp19_ = title;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp19_, 6);
	_tmp20_ = title;
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
	_tmp22_ = _g_object_ref0 (_tmp21_);
	title_context = _tmp22_;
	_tmp23_ = title_context;
	gtk_style_context_add_class (_tmp23_, GRANITE_STYLE_CLASS_H2_LABEL);
	_tmp24_ = title_context;
	_tmp25_ = self->priv->_color;
	_tmp26_ = color_style_class (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_strdup_printf ("%s", _tmp27_);
	_tmp29_ = _tmp28_;
	gtk_style_context_add_class (_tmp24_, _tmp29_);
	_g_free0 (_tmp29_);
	_g_free0 (_tmp27_);
	_tmp30_ = granite_mode_switch_new_from_icon_name ("preferences-color-symbolic", "applications-development-symbolic");
	g_object_ref_sink (_tmp30_);
	toggle = _tmp30_;
	_tmp31_ = toggle;
	granite_mode_switch_set_primary_icon_tooltip_text (_tmp31_, _ ("Hex value"));
	_tmp32_ = toggle;
	granite_mode_switch_set_secondary_icon_tooltip_text (_tmp32_, _ ("Gtk.CSS color constant"));
	_tmp33_ = toggle;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp33_, 6);
	_tmp34_ = toggle;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp34_, 6);
	_tmp35_ = toggle;
	gtk_widget_set_valign ((GtkWidget*) _tmp35_, GTK_ALIGN_CENTER);
	_tmp36_ = toggle;
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
	_tmp38_ = self->priv->_color;
	_tmp39_ = color_style_class (_tmp38_);
	_tmp40_ = _tmp39_;
	_tmp41_ = g_strdup_printf ("%s", _tmp40_);
	_tmp42_ = _tmp41_;
	gtk_style_context_add_class (_tmp37_, _tmp42_);
	_g_free0 (_tmp42_);
	_g_free0 (_tmp40_);
	_tmp43_ = self->priv->_color;
	_tmp44_ = color_uses (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = g_strdup_printf (_ ("<b>Uses:</b> %s"), _tmp45_);
	_tmp47_ = _tmp46_;
	_tmp48_ = (GtkLabel*) gtk_label_new (_tmp47_);
	g_object_ref_sink (_tmp48_);
	_tmp49_ = _tmp48_;
	_g_free0 (_tmp47_);
	_g_free0 (_tmp45_);
	uses_label = _tmp49_;
	_tmp50_ = uses_label;
	g_object_set ((GtkWidget*) _tmp50_, "margin", 6, NULL);
	_tmp51_ = uses_label;
	gtk_label_set_max_width_chars (_tmp51_, 30);
	_tmp52_ = uses_label;
	gtk_label_set_use_markup (_tmp52_, TRUE);
	_tmp53_ = uses_label;
	g_object_set (_tmp53_, "wrap", TRUE, NULL);
	_tmp54_ = uses_label;
	gtk_label_set_xalign (_tmp54_, (gfloat) 0);
	_tmp55_ = uses_label;
	_tmp56_ = gtk_widget_get_style_context ((GtkWidget*) _tmp55_);
	_tmp57_ = self->priv->_color;
	_tmp58_ = color_style_class (_tmp57_);
	_tmp59_ = _tmp58_;
	_tmp60_ = g_strdup_printf ("%s", _tmp59_);
	_tmp61_ = _tmp60_;
	gtk_style_context_add_class (_tmp56_, _tmp61_);
	_g_free0 (_tmp61_);
	_g_free0 (_tmp59_);
	row = 1;
	{
		gint* variant_collection = NULL;
		gint variant_collection_length1 = 0;
		gint _variant_collection_size_ = 0;
		gint variant_it = 0;
		variant_collection = COLOR_BUTTON_VARIANTS;
		variant_collection_length1 = G_N_ELEMENTS (COLOR_BUTTON_VARIANTS);
		for (variant_it = 0; variant_it < variant_collection_length1; variant_it = variant_it + 1) {
			gint variant = 0;
			variant = variant_collection[variant_it];
			{
				ColorVariant* color_variant = NULL;
				Color _tmp62_;
				GtkPopover* _tmp63_;
				GraniteModeSwitch* _tmp64_;
				ColorVariant* _tmp65_;
				GtkGrid* _tmp66_;
				ColorVariant* _tmp67_;
				gint _tmp68_;
				Color _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
				Color _tmp72_;
				GeeHashMap* _tmp73_;
				GeeHashMap* _tmp74_;
				gpointer _tmp75_;
				gchar* _tmp76_;
				_tmp62_ = self->priv->_color;
				_tmp63_ = _data3_->color_menu;
				_tmp64_ = toggle;
				_tmp65_ = color_variant_new (_tmp62_, variant, _tmp63_, _tmp64_);
				g_object_ref_sink (_tmp65_);
				color_variant = _tmp65_;
				_tmp66_ = color_grid;
				_tmp67_ = color_variant;
				_tmp68_ = row;
				row = _tmp68_ + 1;
				gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp67_, 0, _tmp68_, 2, 1);
				_tmp69_ = self->priv->_color;
				_tmp70_ = color_style_class (_tmp69_);
				_tmp71_ = _tmp70_;
				_tmp72_ = self->priv->_color;
				_tmp73_ = color_hex (_tmp72_);
				_tmp74_ = _tmp73_;
				_tmp75_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp74_, (gpointer) ((gintptr) variant));
				_tmp76_ = (gchar*) _tmp75_;
				color_button_add_styles (self, _tmp71_, variant, _tmp76_);
				_g_free0 (_tmp76_);
				_g_object_unref0 (_tmp74_);
				_g_free0 (_tmp71_);
				_g_object_unref0 (color_variant);
			}
		}
	}
	_tmp77_ = row;
	row = _tmp77_ + 1;
	title_row = _tmp77_;
	_tmp78_ = color_grid;
	_tmp79_ = title;
	gtk_grid_attach (_tmp78_, (GtkWidget*) _tmp79_, 0, title_row, 1, 1);
	_tmp80_ = color_grid;
	_tmp81_ = toggle;
	gtk_grid_attach (_tmp80_, (GtkWidget*) _tmp81_, 1, title_row, 1, 1);
	_tmp82_ = color_grid;
	_tmp83_ = uses_label;
	_tmp84_ = row;
	row = _tmp84_ + 1;
	gtk_grid_attach (_tmp82_, (GtkWidget*) _tmp83_, 0, _tmp84_, 2, 1);
	_tmp85_ = color_context;
	_tmp86_ = self->priv->_color;
	_tmp87_ = color_style_class (_tmp86_);
	_tmp88_ = _tmp87_;
	_tmp89_ = g_strdup_printf ("%s-%i", _tmp88_, 500);
	_tmp90_ = _tmp89_;
	gtk_style_context_add_class (_tmp85_, _tmp90_);
	_g_free0 (_tmp90_);
	_g_free0 (_tmp88_);
	_tmp91_ = color_grid;
	gtk_widget_show_all ((GtkWidget*) _tmp91_);
	_tmp92_ = _data3_->color_menu;
	gtk_menu_button_set_popover ((GtkMenuButton*) self, _tmp92_);
	_tmp93_ = gdk_screen_get_default ();
	_tmp94_ = _g_object_ref0 (_tmp93_);
	screen = _tmp94_;
	_tmp95_ = screen;
	_tmp96_ = gdk_screen_get_display (_tmp95_);
	_tmp97_ = _g_object_ref0 (_tmp96_);
	display = _tmp97_;
	_tmp98_ = display;
	_tmp99_ = gdk_display_get_primary_monitor (_tmp98_);
	_tmp100_ = _g_object_ref0 (_tmp99_);
	monitor = _tmp100_;
	_tmp101_ = monitor;
	gdk_monitor_get_geometry (_tmp101_, &_tmp102_);
	_tmp103_ = _tmp102_;
	_data3_->geometry = _tmp103_;
	_tmp104_ = _data3_->color_menu;
	g_signal_connect_data ((GtkWidget*) _tmp104_, "map", (GCallback) __color_button___lambda7__gtk_widget_map, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp105_ = _data3_->color_menu;
	g_signal_connect_data ((GtkWidget*) _tmp105_, "unmap", (GCallback) __color_button___lambda8__gtk_widget_unmap, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_g_object_unref0 (monitor);
	_g_object_unref0 (display);
	_g_object_unref0 (screen);
	_g_object_unref0 (uses_label);
	_g_object_unref0 (toggle);
	_g_object_unref0 (title_context);
	_g_object_unref0 (title);
	_g_object_unref0 (color_grid);
	_g_object_unref0 (color_context);
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return obj;
}

static void
color_button_class_init (ColorButtonClass * klass,
                         gpointer klass_data)
{
	color_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ColorButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_color_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_color_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = color_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = color_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLOR_BUTTON_COLOR_PROPERTY, color_button_properties[COLOR_BUTTON_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", TYPE_COLOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
color_button_instance_init (ColorButton * self,
                            gpointer klass)
{
	self->priv = color_button_get_instance_private (self);
}

static void
color_button_finalize (GObject * obj)
{
	ColorButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLOR_BUTTON, ColorButton);
	G_OBJECT_CLASS (color_button_parent_class)->finalize (obj);
}

static GType
color_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ColorButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) color_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ColorButton), 0, (GInstanceInitFunc) color_button_instance_init, NULL };
	GType color_button_type_id;
	color_button_type_id = g_type_register_static (gtk_menu_button_get_type (), "ColorButton", &g_define_type_info, 0);
	ColorButton_private_offset = g_type_add_instance_private (color_button_type_id, sizeof (ColorButtonPrivate));
	return color_button_type_id;
}

GType
color_button_get_type (void)
{
	static volatile gsize color_button_type_id__once = 0;
	if (g_once_init_enter (&color_button_type_id__once)) {
		GType color_button_type_id;
		color_button_type_id = color_button_get_type_once ();
		g_once_init_leave (&color_button_type_id__once, color_button_type_id);
	}
	return color_button_type_id__once;
}

static void
_vala_color_button_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ColorButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COLOR_BUTTON, ColorButton);
	switch (property_id) {
		case COLOR_BUTTON_COLOR_PROPERTY:
		g_value_set_enum (value, color_button_get_color (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_color_button_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ColorButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COLOR_BUTTON, ColorButton);
	switch (property_id) {
		case COLOR_BUTTON_COLOR_PROPERTY:
		color_button_set_color (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

