/* ColorVariant.c generated by valac 0.56.16, the Vala compiler
 * generated from ColorVariant.vala, do not modify */

/*
* Copyright © 2018–2021 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <granite.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_COLOR_VARIANT (color_variant_get_type ())
#define COLOR_VARIANT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_VARIANT, ColorVariant))
#define COLOR_VARIANT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_VARIANT, ColorVariantClass))
#define IS_COLOR_VARIANT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_VARIANT))
#define IS_COLOR_VARIANT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_VARIANT))
#define COLOR_VARIANT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_VARIANT, ColorVariantClass))

typedef struct _ColorVariant ColorVariant;
typedef struct _ColorVariantClass ColorVariantClass;
typedef struct _ColorVariantPrivate ColorVariantPrivate;
typedef enum  {
	COLOR_STRAWBERRY,
	COLOR_ORANGE,
	COLOR_BANANA,
	COLOR_LIME,
	COLOR_MINT,
	COLOR_BLUEBERRY,
	COLOR_GRAPE,
	COLOR_BUBBLEGUM,
	COLOR_COCOA,
	COLOR_SILVER,
	COLOR_SLATE,
	COLOR_BLACK
} Color;

#define TYPE_COLOR (color_get_type ())
enum  {
	COLOR_VARIANT_0_PROPERTY,
	COLOR_VARIANT_COLOR_PROPERTY,
	COLOR_VARIANT_VARIANT_PROPERTY,
	COLOR_VARIANT_COLOR_MENU_PROPERTY,
	COLOR_VARIANT_TOGGLE_PROPERTY,
	COLOR_VARIANT_NUM_PROPERTIES
};
static GParamSpec* color_variant_properties[COLOR_VARIANT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ColorVariant {
	GtkButton parent_instance;
	ColorVariantPrivate * priv;
	gchar* to_copy;
};

struct _ColorVariantClass {
	GtkButtonClass parent_class;
};

struct _ColorVariantPrivate {
	Color _color;
	gint _variant;
	GtkPopover* _color_menu;
	GraniteModeSwitch* _toggle;
	GtkLabel* variant_label;
	GtkRevealer* hex_label_revealer;
	GtkRevealer* const_label_revealer;
};

struct _Block4Data {
	int _ref_count_;
	ColorVariant* self;
	gchar* hex;
	gchar* css_var;
};

static gint ColorVariant_private_offset;
static gpointer color_variant_parent_class = NULL;
VALA_EXTERN GSettings* palette_settings;

VALA_EXTERN GType color_variant_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ColorVariant, g_object_unref)
VALA_EXTERN GType color_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ColorVariant* color_variant_new (Color color,
                                 gint variant,
                                 GtkPopover* color_menu,
                                 GraniteModeSwitch* toggle);
VALA_EXTERN ColorVariant* color_variant_construct (GType object_type,
                                       Color color,
                                       gint variant,
                                       GtkPopover* color_menu,
                                       GraniteModeSwitch* toggle);
static void color_variant_real_realize (GtkWidget* base);
VALA_EXTERN GraniteModeSwitch* color_variant_get_toggle (ColorVariant* self);
VALA_EXTERN Color color_variant_get_color (ColorVariant* self);
static void color_variant_set_color (ColorVariant* self,
                              Color value);
VALA_EXTERN gint color_variant_get_variant (ColorVariant* self);
static void color_variant_set_variant (ColorVariant* self,
                                gint value);
VALA_EXTERN GtkPopover* color_variant_get_color_menu (ColorVariant* self);
static void color_variant_set_color_menu (ColorVariant* self,
                                   GtkPopover* value);
static void color_variant_set_toggle (ColorVariant* self,
                               GraniteModeSwitch* value);
static GObject * color_variant_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN gchar* color_style_class (Color self);
VALA_EXTERN GeeHashMap* color_hex (Color self);
static void _color_variant___lambda5_ (Block4Data* _data4_);
static void __color_variant___lambda5__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void _color_variant___lambda6_ (ColorVariant* self);
static void __color_variant___lambda6__gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self);
static void color_variant_finalize (GObject * obj);
static GType color_variant_get_type_once (void);
static void _vala_color_variant_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_color_variant_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
color_variant_get_instance_private (ColorVariant* self)
{
	return G_STRUCT_MEMBER_P (self, ColorVariant_private_offset);
}

ColorVariant*
color_variant_construct (GType object_type,
                         Color color,
                         gint variant,
                         GtkPopover* color_menu,
                         GraniteModeSwitch* toggle)
{
	ColorVariant * self = NULL;
	g_return_val_if_fail (color_menu != NULL, NULL);
	g_return_val_if_fail (toggle != NULL, NULL);
	self = (ColorVariant*) g_object_new (object_type, "color", color, "color-menu", color_menu, "height-request", 48, "hexpand", TRUE, "toggle", toggle, "variant", variant, NULL);
	return self;
}

ColorVariant*
color_variant_new (Color color,
                   gint variant,
                   GtkPopover* color_menu,
                   GraniteModeSwitch* toggle)
{
	return color_variant_construct (TYPE_COLOR_VARIANT, color, variant, color_menu, toggle);
}

static void
color_variant_real_realize (GtkWidget* base)
{
	ColorVariant * self;
	GSettings* _tmp0_;
	GraniteModeSwitch* _tmp1_;
	GSettings* _tmp2_;
	GtkRevealer* _tmp3_;
	GSettings* _tmp4_;
	GtkRevealer* _tmp5_;
	self = (ColorVariant*) base;
	GTK_WIDGET_CLASS (color_variant_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_button_get_type (), GtkButton));
	_tmp0_ = palette_settings;
	_tmp1_ = self->priv->_toggle;
	g_settings_bind (_tmp0_, "developer-mode", (GObject*) _tmp1_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp2_ = palette_settings;
	_tmp3_ = self->priv->const_label_revealer;
	g_settings_bind (_tmp2_, "developer-mode", (GObject*) _tmp3_, "reveal-child", G_SETTINGS_BIND_GET);
	_tmp4_ = palette_settings;
	_tmp5_ = self->priv->hex_label_revealer;
	g_settings_bind (_tmp4_, "developer-mode", (GObject*) _tmp5_, "reveal-child", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_INVERT_BOOLEAN);
}

Color
color_variant_get_color (ColorVariant* self)
{
	Color result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_color;
	return result;
}

static void
color_variant_set_color (ColorVariant* self,
                         Color value)
{
	Color old_value;
	g_return_if_fail (self != NULL);
	old_value = color_variant_get_color (self);
	if (old_value != value) {
		self->priv->_color = value;
		g_object_notify_by_pspec ((GObject *) self, color_variant_properties[COLOR_VARIANT_COLOR_PROPERTY]);
	}
}

gint
color_variant_get_variant (ColorVariant* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_variant;
	return result;
}

static void
color_variant_set_variant (ColorVariant* self,
                           gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = color_variant_get_variant (self);
	if (old_value != value) {
		self->priv->_variant = value;
		g_object_notify_by_pspec ((GObject *) self, color_variant_properties[COLOR_VARIANT_VARIANT_PROPERTY]);
	}
}

GtkPopover*
color_variant_get_color_menu (ColorVariant* self)
{
	GtkPopover* result;
	GtkPopover* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_color_menu;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
color_variant_set_color_menu (ColorVariant* self,
                              GtkPopover* value)
{
	GtkPopover* old_value;
	g_return_if_fail (self != NULL);
	old_value = color_variant_get_color_menu (self);
	if (old_value != value) {
		GtkPopover* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_color_menu);
		self->priv->_color_menu = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, color_variant_properties[COLOR_VARIANT_COLOR_MENU_PROPERTY]);
	}
}

GraniteModeSwitch*
color_variant_get_toggle (ColorVariant* self)
{
	GraniteModeSwitch* result;
	GraniteModeSwitch* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_toggle;
	result = _tmp0_;
	return result;
}

static void
color_variant_set_toggle (ColorVariant* self,
                          GraniteModeSwitch* value)
{
	GraniteModeSwitch* old_value;
	g_return_if_fail (self != NULL);
	old_value = color_variant_get_toggle (self);
	if (old_value != value) {
		GraniteModeSwitch* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_toggle);
		self->priv->_toggle = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, color_variant_properties[COLOR_VARIANT_TOGGLE_PROPERTY]);
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		ColorVariant* self;
		self = _data4_->self;
		_g_free0 (_data4_->css_var);
		_g_free0 (_data4_->hex);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
_color_variant___lambda5_ (Block4Data* _data4_)
{
	ColorVariant* self;
	GraniteModeSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	self = _data4_->self;
	_tmp0_ = self->priv->_toggle;
	_tmp1_ = granite_mode_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = _data4_->css_var;
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (self->to_copy);
		self->to_copy = _tmp4_;
	} else {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = _data4_->hex;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (self->to_copy);
		self->to_copy = _tmp6_;
	}
	_tmp7_ = self->to_copy;
	_tmp8_ = g_strdup_printf (_ ("Copy %s to clipboard"), _tmp7_);
	_tmp9_ = _tmp8_;
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp9_);
	_g_free0 (_tmp9_);
}

static void
__color_variant___lambda5__g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
	_color_variant___lambda5_ (self);
}

static void
_color_variant___lambda6_ (ColorVariant* self)
{
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	const gchar* _tmp2_;
	GtkPopover* _tmp3_;
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = gtk_clipboard_get_default (_tmp0_);
	_tmp2_ = self->to_copy;
	gtk_clipboard_set_text (_tmp1_, _tmp2_, -1);
	_tmp3_ = self->priv->_color_menu;
	gtk_popover_popdown (_tmp3_);
}

static void
__color_variant___lambda6__gtk_button_clicked (GtkButton* _sender,
                                               gpointer self)
{
	_color_variant___lambda6_ ((ColorVariant*) self);
}

static GObject *
color_variant_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ColorVariant * self;
	Block4Data* _data4_;
	GtkStyleContext* _tmp0_;
	Color _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	Color _tmp7_;
	GeeHashMap* _tmp8_;
	GeeHashMap* _tmp9_;
	gint _tmp10_;
	gpointer _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* hex_label = NULL;
	const gchar* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkStyleContext* _tmp32_;
	GtkRevealer* _tmp33_;
	GtkRevealer* _tmp34_;
	GtkRevealer* _tmp35_;
	GtkLabel* _tmp36_;
	gchar* caps = NULL;
	Color _tmp37_;
	GEnumValue* _tmp38_;
	gchar* _tmp39_;
	const gchar* _tmp40_;
	gint _tmp41_;
	gchar* _tmp42_;
	GtkLabel* const_label = NULL;
	const gchar* _tmp43_;
	GtkLabel* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkStyleContext* _tmp49_;
	GtkRevealer* _tmp50_;
	GtkRevealer* _tmp51_;
	GtkRevealer* _tmp52_;
	GtkLabel* _tmp53_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkRevealer* _tmp58_;
	GtkGrid* _tmp59_;
	GtkRevealer* _tmp60_;
	GtkGrid* _tmp61_;
	GraniteModeSwitch* _tmp62_;
	parent_class = G_OBJECT_CLASS (color_variant_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLOR_VARIANT, ColorVariant);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = self->priv->_color;
	_tmp2_ = color_style_class (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_variant;
	_tmp5_ = g_strdup_printf ("%s-%i", _tmp3_, _tmp4_);
	_tmp6_ = _tmp5_;
	gtk_style_context_add_class (_tmp0_, _tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
	_tmp7_ = self->priv->_color;
	_tmp8_ = color_hex (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->_variant;
	_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) _tmp10_));
	_tmp12_ = (gchar*) _tmp11_;
	_g_object_unref0 (_tmp9_);
	_data4_->hex = _tmp12_;
	_tmp13_ = _data4_->hex;
	_tmp14_ = g_strdup (_tmp13_);
	_g_free0 (self->to_copy);
	self->to_copy = _tmp14_;
	_tmp15_ = self->to_copy;
	_tmp16_ = g_strdup_printf (_ ("Copy %s to clipboard"), _tmp15_);
	_tmp17_ = _tmp16_;
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp17_);
	_g_free0 (_tmp17_);
	_tmp18_ = self->priv->_variant;
	_tmp19_ = g_strdup_printf ("<b>%i</b>", _tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = (GtkLabel*) gtk_label_new (_tmp20_);
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->variant_label);
	self->priv->variant_label = _tmp21_;
	_g_free0 (_tmp20_);
	_tmp22_ = self->priv->variant_label;
	g_object_set ((GtkWidget*) _tmp22_, "expand", TRUE, NULL);
	_tmp23_ = self->priv->variant_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_START);
	_tmp24_ = self->priv->variant_label;
	gtk_label_set_use_markup (_tmp24_, TRUE);
	_tmp25_ = self->priv->variant_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_CENTER);
	_tmp26_ = _data4_->hex;
	_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
	g_object_ref_sink (_tmp27_);
	hex_label = _tmp27_;
	_tmp28_ = hex_label;
	g_object_set ((GtkWidget*) _tmp28_, "expand", TRUE, NULL);
	_tmp29_ = hex_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_END);
	_tmp30_ = hex_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp30_, GTK_ALIGN_CENTER);
	_tmp31_ = hex_label;
	_tmp32_ = gtk_widget_get_style_context ((GtkWidget*) _tmp31_);
	gtk_style_context_add_class (_tmp32_, "monospace");
	_tmp33_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->hex_label_revealer);
	self->priv->hex_label_revealer = _tmp33_;
	_tmp34_ = self->priv->hex_label_revealer;
	gtk_revealer_set_transition_type (_tmp34_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	_tmp35_ = self->priv->hex_label_revealer;
	_tmp36_ = hex_label;
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->_color;
	_tmp38_ = g_enum_get_value (g_type_class_ref (TYPE_COLOR), _tmp37_);
	_tmp39_ = string_replace ((_tmp38_ != NULL) ? _tmp38_->value_name : NULL, "COLOR_", "");
	caps = _tmp39_;
	_tmp40_ = caps;
	_tmp41_ = self->priv->_variant;
	_tmp42_ = g_strdup_printf ("@%s_%i", _tmp40_, _tmp41_);
	_data4_->css_var = _tmp42_;
	_tmp43_ = _data4_->css_var;
	_tmp44_ = (GtkLabel*) gtk_label_new (_tmp43_);
	g_object_ref_sink (_tmp44_);
	const_label = _tmp44_;
	_tmp45_ = const_label;
	g_object_set ((GtkWidget*) _tmp45_, "expand", TRUE, NULL);
	_tmp46_ = const_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp46_, GTK_ALIGN_END);
	_tmp47_ = const_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp47_, GTK_ALIGN_CENTER);
	_tmp48_ = const_label;
	_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) _tmp48_);
	gtk_style_context_add_class (_tmp49_, "monospace");
	_tmp50_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp50_);
	_g_object_unref0 (self->priv->const_label_revealer);
	self->priv->const_label_revealer = _tmp50_;
	_tmp51_ = self->priv->const_label_revealer;
	gtk_revealer_set_transition_type (_tmp51_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	_tmp52_ = self->priv->const_label_revealer;
	_tmp53_ = const_label;
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
	_tmp54_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp54_);
	grid = _tmp54_;
	_tmp55_ = grid;
	_tmp56_ = self->priv->variant_label;
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 0, 0, 1, 1);
	_tmp57_ = grid;
	_tmp58_ = self->priv->hex_label_revealer;
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 1, 0, 1, 1);
	_tmp59_ = grid;
	_tmp60_ = self->priv->const_label_revealer;
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 1, 0, 1, 1);
	_tmp61_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp61_);
	_tmp62_ = self->priv->_toggle;
	g_signal_connect_data ((GObject*) _tmp62_, "notify::active", (GCallback) __color_variant___lambda5__g_object_notify, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	g_signal_connect_object ((GtkButton*) self, "clicked", (GCallback) __color_variant___lambda6__gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (const_label);
	_g_free0 (caps);
	_g_object_unref0 (hex_label);
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return obj;
}

static void
color_variant_class_init (ColorVariantClass * klass,
                          gpointer klass_data)
{
	color_variant_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ColorVariant_private_offset);
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) color_variant_real_realize;
	G_OBJECT_CLASS (klass)->get_property = _vala_color_variant_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_color_variant_set_property;
	G_OBJECT_CLASS (klass)->constructor = color_variant_constructor;
	G_OBJECT_CLASS (klass)->finalize = color_variant_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLOR_VARIANT_COLOR_PROPERTY, color_variant_properties[COLOR_VARIANT_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", TYPE_COLOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLOR_VARIANT_VARIANT_PROPERTY, color_variant_properties[COLOR_VARIANT_VARIANT_PROPERTY] = g_param_spec_int ("variant", "variant", "variant", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLOR_VARIANT_COLOR_MENU_PROPERTY, color_variant_properties[COLOR_VARIANT_COLOR_MENU_PROPERTY] = g_param_spec_object ("color-menu", "color-menu", "color-menu", gtk_popover_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLOR_VARIANT_TOGGLE_PROPERTY, color_variant_properties[COLOR_VARIANT_TOGGLE_PROPERTY] = g_param_spec_object ("toggle", "toggle", "toggle", GRANITE_TYPE_MODE_SWITCH, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
color_variant_instance_init (ColorVariant * self,
                             gpointer klass)
{
	self->priv = color_variant_get_instance_private (self);
}

static void
color_variant_finalize (GObject * obj)
{
	ColorVariant * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLOR_VARIANT, ColorVariant);
	_g_object_unref0 (self->priv->_color_menu);
	_g_object_unref0 (self->priv->_toggle);
	_g_object_unref0 (self->priv->variant_label);
	_g_object_unref0 (self->priv->hex_label_revealer);
	_g_object_unref0 (self->priv->const_label_revealer);
	_g_free0 (self->to_copy);
	G_OBJECT_CLASS (color_variant_parent_class)->finalize (obj);
}

static GType
color_variant_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ColorVariantClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) color_variant_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ColorVariant), 0, (GInstanceInitFunc) color_variant_instance_init, NULL };
	GType color_variant_type_id;
	color_variant_type_id = g_type_register_static (gtk_button_get_type (), "ColorVariant", &g_define_type_info, 0);
	ColorVariant_private_offset = g_type_add_instance_private (color_variant_type_id, sizeof (ColorVariantPrivate));
	return color_variant_type_id;
}

GType
color_variant_get_type (void)
{
	static volatile gsize color_variant_type_id__once = 0;
	if (g_once_init_enter (&color_variant_type_id__once)) {
		GType color_variant_type_id;
		color_variant_type_id = color_variant_get_type_once ();
		g_once_init_leave (&color_variant_type_id__once, color_variant_type_id);
	}
	return color_variant_type_id__once;
}

static void
_vala_color_variant_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ColorVariant * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COLOR_VARIANT, ColorVariant);
	switch (property_id) {
		case COLOR_VARIANT_COLOR_PROPERTY:
		g_value_set_enum (value, color_variant_get_color (self));
		break;
		case COLOR_VARIANT_VARIANT_PROPERTY:
		g_value_set_int (value, color_variant_get_variant (self));
		break;
		case COLOR_VARIANT_COLOR_MENU_PROPERTY:
		g_value_set_object (value, color_variant_get_color_menu (self));
		break;
		case COLOR_VARIANT_TOGGLE_PROPERTY:
		g_value_set_object (value, color_variant_get_toggle (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_color_variant_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ColorVariant * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COLOR_VARIANT, ColorVariant);
	switch (property_id) {
		case COLOR_VARIANT_COLOR_PROPERTY:
		color_variant_set_color (self, g_value_get_enum (value));
		break;
		case COLOR_VARIANT_VARIANT_PROPERTY:
		color_variant_set_variant (self, g_value_get_int (value));
		break;
		case COLOR_VARIANT_COLOR_MENU_PROPERTY:
		color_variant_set_color_menu (self, g_value_get_object (value));
		break;
		case COLOR_VARIANT_TOGGLE_PROPERTY:
		color_variant_set_toggle (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

